%global momorel 2
%global _debug 0
%global modutils_ver 2.4.25

Summary: The kernel daemon (kerneld) and kernel module utilities.
Name: module-init-tools
Version: 3.1
Release: %{momorel}m
License: GPL
Group: System Environment/Kernel
URL: http://www.kernel.org/pub/linux/utils/kernel/module-init-tools/
%NoSource 0 http://www.kernel.org/pub/linux/utils/kernel/module-init-tools/module-init-tools-%{version}.tar.bz2 8ddecbcf0e56aef8617f67a3906faf3e
%NoSource 1 http://www.kernel.org/pub/linux/utils/kernel/modutils/v2.4/modutils-%{modutils_ver}.tar.bz2 2c0cca3ef6330a187c6ef4fe41ecaa4d
# This is not used anymore, but we like it sitting around
Source2: kerneld.init
Source3: kmod.crond

## 1000- are patches for modutils
Patch1000: kondara-modutils-2.4.13-systemmap.patch
Patch1001: modutils-2.4.2-prepost.patch
Patch1002: modutils-2.4.6-silence.patch
Patch1010: modutils-2.3.17-alsa.patch
Patch1101: modutils-2.4.18-small.patch


Exclusiveos: Linux
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPreReq: flex, bison
BuildPreReq: zlib-devel >= 1.2.2-2m
Prereq: chkconfig
Requires: vixie-cron >= 3.0.1-31
Requires: mkinitrd >= 3.4.43-8m
Obsoletes: modules
Obsoletes: modutils
Provides: modutils = %{modutils_ver}

%ifarch %ix86 alpha
BuildPrereq: dietlibc
%define buildcc	diet gcc
%else
%define buildcc	gcc
%endif

%description
The modutils packages includes the various programs neeed for automatic
loading and unloading of modules under 2.2 and later kernels as well as
other module management programs.  Examples of loaded and unloaded
modules are device drivers and filesystems, as well as some other things.

%package devel
Summary: Kernel module management utilities development libraries.
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Obsoletes: modutils-devel
Provides: modutils-devel = %{modutils_ver}

%description devel
The modutils-devel package includes library archives that allow programs
to implement insmod and rmmod.  Developers should not use these libraries,
they are for internal use only.


%prep
rm -rf %{buildroot}
%setup -q -a1

pushd modutils-%{modutils_ver}
%patch1000 -p1
%patch1001 -p1
%patch1002 -p1
%patch1010 -p1
popd

%build
aclocal-1.6
#autoheader-2.58
automake-1.6 --add-missing --force --copy
autoconf
%configure --enable-zlib --exec_prefix=/
%make

pushd modutils-%{modutils_ver}

  export CC="%buildcc"
  export CFLAGS="-Os"

  # insmod.static (diet)

  %configure --disable-compat-2-0 --disable-kerneld --enable-insmod-static \
	  --exec_prefix=/ --disable-combined
  make -C obj %{?_smp_mflags} libobj.a
  make -C util %{?_smp_mflags} libutil.a
  make -C insmod %{?_smp_mflags} insmod.static
  cp insmod/insmod.static ./insmod.static
  make distclean

  # installer use (diet, various code paths patched out)

  patch -p1 -b --suffix .loader < %{PATCH1101}
  export CFLAGS="-Os -D__LOADER__ -Dxstrdup=strdup -Dxmalloc=malloc -Dxrealloc=realloc -Dxstrcat=strncat"
  %configure --disable-compat-2-0 --disable-kerneld --enable-insmod-static \
	  --exec_prefix=/ --disable-combined --enable-combined-rmmod
  make -C obj %{?_smp_mflags} dep all
  make -C util %{?_smp_mflags} dep all
  make -C insmod %{?_smp_mflags} dep all
  mkdir libs
  cp util/libutil.a libs/libmodutilutil.a
  cp obj/libobj.a libs/libmodutilobj.a
  cp insmod/libmodutils.a libs
  patch -R -p1 < %{PATCH1101}
  make distclean

  # normal

  export CC=gcc
  export CFLAGS="$RPM_OPT_FLAGS"
  %configure --disable-compat-2-0 --disable-kerneld --exec_prefix=/
  make %{?_smp_mflags} dep all

popd

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_initscriptdir}
mkdir -p %{buildroot}/etc/cron.d
mkdir -p %{buildroot}/sbin
mkdir -p %{buildroot}/%{_libdir}
mkdir -p %{buildroot}/bin

pushd modutils-%{modutils_ver}

  %makeinstall sbindir=%{buildroot}/sbin

  rm -f %{buildroot}/%{_mandir}/man8/{kdstat,kerneld}.8

  find %{buildroot}/sbin/ -name '*.static' -exec rm {} \;

  install -m 755 insmod.static %{buildroot}/sbin/insmod.static.old

  install -m 644 libs/*.a %{buildroot}/%{_libdir}

popd

for f in lsmod modprobe rmmod depmod insmod modinfo; do
  if [ -L %{buildroot}/sbin/$f ]; then
    ln -sf `ls -l %{buildroot}/sbin/$f | sed 's/.* -> //'`.old %{buildroot}/sbin/$f
  fi
  mv %{buildroot}/sbin/$f %{buildroot}/sbin/$f.old
  if [ -f %{buildroot}%{_mandir}/man8/$f.8.gz ]; then
    mv %{buildroot}%{_mandir}/man8/$f.8.gz
       %{buildroot}%{_mandir}/man8/$f.old.8.gz
  elif [ -f %{buildroot}%{_mandir}/man8/$f.8.bz2 ]; then
    mv %{buildroot}%{_mandir}/man8/$f.8.bz2
       %{buildroot}%{_mandir}/man8/$f.old.8.bz2
  else
    mv %{buildroot}%{_mandir}/man8/$f.8 %{buildroot}%{_mandir}/man8/$f.old.8
  fi
done
for f in kallsyms ksyms; do
  if [ -L %{buildroot}/sbin/$f ]; then
    ln -sf `ls -l %{buildroot}/sbin/$f | sed 's/.* -> //'`.old %{buildroot}/sbin/$f
  fi
done
ln -sf ../sbin/lsmod.old %{buildroot}/bin/lsmod.old

%makeinstall bindir=%{buildroot}/bin sbindir=%{buildroot}/sbin transform='s,x,x,'
mv %{buildroot}/bin/lsmod %{buildroot}/sbin/lsmod
ln -sf ../sbin/lsmod %{buildroot}/bin/lsmod

%clean
rm -rf %{buildroot}

%post
# get rid of the old installations on upgrade
if [ -x %{_initscriptdir}/kerneld ] ; then
    /sbin/chkconfig --del kerneld
fi
if [ -f /etc/conf.modules -a ! -f /etc/modules.conf ] ; then
   mv -f /etc/conf.modules /etc/modules.conf
fi

%files
%defattr(-,root,root)
/sbin/*
/bin/*
%{_mandir}/*/*

%files devel
%defattr(-,root,root)
%{_libdir}/*.a

%changelog
* Tue Jul 12 2005 Ryu SASAOKA <ryu@momonga-linux.org>
- (3.1-2m)
- rebuild against zlib-devel 1.2.2-2m, which fixes CAN-2005-2096.

* Sun Mar 27 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (3.1-1m)
- up to 3.1

* Tue Aug 10 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (3.0-2m)
- use autoconf instead of autoconf-2.58

* Mon Apr 26 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (3.0-1m)
- updated to 3.0

* Fri Dec 19 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (0.9.14-5m)
- change URL

* Mon Dec 15 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (0.9.14-4m)
- fix insmod.static with zlib
- renumber patches

* Mon Dec 15 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (0.9.14-3m)
- remove enable-zlib from configure of module-init-tools

* Wed Dec 10 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (0.9.14-2m)
- rename static insmod of modutils to insmod.static.old

* Sat Dec  6 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (0.9.14-1m)
- change name to module-init-tools
- add module-init-tools for kernel 2.6

* Tue Jun  3 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.4.25-1m)
  update to 2.4.25
  
* Sun Feb 16 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.4.22-1m)
  update to 2.4.22

* Wed Oct 30 2002 KOMATSU Shinichiro <koma2@jiro.c.u-tokyo.ac.jp>
- (2.4.21-2m)
- add BuildPrereq: dietlibc on %%ix86 and alpha

* Tue Oct 22 2002 KOMATSU Shinichiro <koma2@jiro.c.u-tokyo.ac.jp>
- (2.4.21-1m)
  update to 2.4.21

* Fri Sep  6 2002 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.4.20-1m)
  update to 2.4.20

* Tue Sep  3 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (2.4.19-2m)
- add "Requires: %{name} = %{version}-%{release}" to -devel

* Wed Aug  7 2002 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.4.19-1m)
  update to 2.4.19
  
* Wed Jul 24 2002 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.4.18-1m)
  update to 2.4.18

* Mon May  6 2002 Tsutomu Yasuda <tom@kondara.org>
- (2.4.16-2k)
  update to 2.4.16

* Thu Apr  4 2002 Tsutomu Yasuda <tom@kondara.org>
- (2.4.15-2k)
  update to 2.4.15

* Sun Mar 31 2002 Toru Hoshina <t@kondara.org>
- (2.4.14-2k)
- update to 2.4.14
- separate -devel.

* Mon Feb 25 2002 Tsutomu Yasuda <tom@kondara.org>
- (2.4.13-2k)
- update to 2.4.13

* Tue Jan 22 2002 MATSUDA, Daiki <dyky@df-usa.com>
- (2.4.12-2k)
- update to 2.4.12

* Sun Jan 13 2002 MATSUDA, Daiki <dyky@df-usa.com>
- (2.4.10-10k)
- add modutils-2.4.10_i2c-dev.patch

* Mon Jan  7 2002 MATSUDA, Daiki <dyky@df-usa.com>
- (2.4.10-8k)
- add modutils-2.4.10-nvidia.patch

* Wed Oct  4 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (2.4.10-6k)
- remove modutils-2.4.10-bahtari.patch, because ieee1394 modules are modified

* Wed Oct  3 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (2.4.10-4k)
- add modutils-2.4.10-bahtari.patch for... T_T

* Tue Oct  2 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (2.4.10-2k)
- update to 2.4.10 and merge to rh 2.4.6-4

* Thu Apr 19 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (2.4.5-2k)
- update to 2.4.5

* Tue Mar 13 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (2.4.3-3k)
- update to 2.4.3

* Mon Jan  8 2001 MATSUDA, Daiki <dyky@dfu-sa.com>
- (2.4.1-3k)
- update to 2.4.1

* Tue Jan  2 2001 Tsutomu Yasuda <tom@digitalfactory.co.jp>
- (2.3.24-3k)
- update to 2.3.24

* Tue Dec 19 2000 MATSUDA, Daiki <dyky@df-usa.com>
- (2.3.23-3k)
- update to 2.3.23

* Sun Dec 10 2000 MATSUDA, Daiki <dyky@df-usa.com>
- (2.3.22-3k)
- update to 2.3.22

* Sun Dec 03 2000 Kenichi Matsubara <m@kondara.org>
- (2.3.20-7k)
- Obsoletes Japanese man.[ conflict man-pages-ja]

* Mon Nov 20 2000 Toyokazu WATABE <toy2@kondara.org>
- (2.3.20-2k, 2.3.20-3k)
- if not jirai, add Japanese man.

* Sun Nov 19 2000 MATSUDA, Daiki <dyky@df-usa.com>
- (2.3.20-1.1k)
- backport for stable version

* Sun Nov 19 2000 MATSUDA, Daiki <dyky@df-usa.com>
- (2.3.20-1k)
- update to 2.3.20 for security fix

* Sat Oct 21 2000 MATSUDA, Daiki <dyky@df-usa.com>
- (2.3.18-1k)
- update to 2.3.18

* Wed Oct  4 2000 MATSUDA, Daiki <dyky@df-usa.com>
- (2.3.17-0k)
- update to 2.3.17
- add alsa patch for upper 2.4.0 kernel

* Thu Aug 10 2000 Toru Hoshina <t@kondara.org>
- Kondarized.

* Wed Jul 19 2000 Jakub Jelinek <jakub@redhat.com>
- rebuild to cope with glibc locale binary incompatibility

* Thu Jul 13 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.3.12
- fix up ia64

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Sat Jul  1 2000 Florian La Roche <laroche@redhat.com>
- add aliases for cipcb[0-3]

* Wed Jun 14 2000 Matt Wilson <msw@redhat.com>
- fix build on combined 32/64 bit sparc

* Thu Jun  1 2000 Bill Nottingham <notting@redhat.com>
- modules.confiscation

* Wed May 17 2000 Bill Nottingham <notting@redhat.com>
- add ia64 patch from Intel

* Wed May 17 2000 Jakub Jelinek <jakub@redhat.com>
- fix build with glibc 2.2

* Tue May 09 2000 Doug Ledford <dledford@redhat.com>
- Correct %description to reflect that we don't build kerneld by default

* Fri Apr 21 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.3.11

* Mon Apr  3 2000 Bill Nottingham <notting@redhat.com>
- fix net-pf-* aliases for ipx, appletalk

* Fri Mar 17 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.3.10

* Thu Feb 17 2000 Matt Wilson <msw@redhat.com>
- added alias for agpgart

* Mon Feb 14 2000 Bill Nottingham <notting@redhat.com>
- hardcode psaux alias to off everywhere

* Thu Feb  3 2000 Bill Nottingham <notting@redhat.com>
- add a symlink from conf.modules.5 to modules.conf.5

* Fri Jan 29 2000 Bill Nottingham <notting@redhat.com>
- fix breakage *correctly*

* Sat Jan 22 2000 Bill Nottingham <notting@redhat.com>
- fix breakage of our own cause w.r.t sound modules

* Thu Jan 06 2000 Jakub Jelinek <jakub@redhat.com>
- update to 2.3.9.
- port RH patches from 2.1.121 to 2.3.9 where needed.
- disable warning about conf.modules for now, in 7.0
  we should move to modules.conf.

* Wed Oct 13 1999 Jakub Jelinek <jakub@redhat.com>
- hardcode psaux alias on sparc to off.

* Tue Oct 05 1999 Bill Nottingham <notting@redhat.com>
- hardcode parport aliases....

* Mon Oct 04 1999 Cristian Gafton <gafton@redhat.com>
- rebuild against new glibc in the sparc tree

* Wed Sep 15 1999 Jakub Jelinek <jakub@redhat.com>
- rewrite sparckludge so that separate *64 binaries
  are not needed anymore.

* Sat Sep 11 1999 Cristian Gafton <gafton@redhat.com>
- apply the last patch in the %prep section (doh!)

* Mon Apr 19 1999 Cristian Gafton <gafton@redhat.com>
- add support for the ppp compression modules by default

* Tue Apr 13 1999 Michael K. Johnson <johnsonm@redhat.com>
- add cron.d file to run rmmod -as

* Fri Apr 09 1999 Cristian Gafton <gafton@redhat.com>
- take out kerneld

* Mon Apr 05 1999 Cristian Gafton <gafton@redhat.com>
- add patch to make all raid personalities recognized

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 7)

* Thu Mar 18 1999 Cristian Gafton <gafton@redhat.com>
- obsoletes modules
- get rid of the /lib/modules/preferred hack

* Mon Mar 15 1999 Bill Nottingham <notting@redhat.com>
- added support for /lib/modules/foo/pcmcia
- make kerneld initscript not start by default

* Tue Feb 23 1999 Matt Wilson <msw@redhat.com>
- added sparc64 support from UltraPenguin

* Tue Jan 12 1999 Cristian Gafton <gafton@redhat.com>
- call libtoolize to allow it to compile on the arm

* Wed Dec 23 1998 Jeff Johnson <jbj@redhat.com>
- search /lib/modules/preferred before defaults but after specified paths.

* Tue Nov 17 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to version 2.1.121

* Thu Nov 05 1998 Erik Troan <ewt@redhat.com>
- added -m, -i options

* Thu Oct 01 1998 Michael K. Johnson <johnsonm@redhat.com>
- fix syntax error I introduced when enhancing initscript

* Wed Sep 30 1998 Michael K. Johnson <johnsonm@redhat.com>
- enhance initscript

* Fri Aug 28 1998 Jeff Johnson <jbj@redhat.com>
- recompile statically linked binary for 5.2/sparc

* Tue Jul 28 1998 Jeff Johnson <jbj@redhat.com>
- pick up ultrapenguin patches (not applied for now).
- pre-generate keyword.c so gperf doesn't have to be present (not applied).
- util/sys_cm.c: fix create_module syscall (signed return on sparc too)

* Wed Jul 15 1998 Jeff Johnson <jbj@redhat.com>
- correct %postun typos

* Fri May 01 1998 Erik Troan <ewt@redhat.com>
- added /lib/modules/preferred to search path

* Fri Apr 24 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Tue Apr 07 1998 Cristian Gafton <gafton@redhat.com>
- updated to 2.1.85
- actually make use of the BuildRoot

* Fri Apr  3 1998 Jakub Jelinek <jj@ultra.linux.cz>
- Fix sparc64, add modinfo64 on sparc.

* Wed Mar 23 1998 Jakub Jelinek <jj@ultra.linux.cz>
- Handle EM_SPARCV9, kludge to support both 32bit and 64bit kernels
  from the same package on sparc/sparc64.

* Fri Nov  7 1997 Michael Fulbright
- removed warning message when conf.modules exists and is a empty

* Tue Oct 28 1997 Erik Troan <ewt@redhat.com>
- patched to honor -k in options
- added modprobe.1
- added init script

* Thu Oct 23 1997 Erik Troan <ewt@redhat.com>
- removed bogus strip of lsmod (which is a script)

* Mon Oct 20 1997 Erik Troan <ewt@redhat.com>
- updated to 2.1.55
- builds in a buildroot

* Mon Aug 25 1997 Erik Troan <ewt@redhat.com>
- added insmod.static

* Sun Aug 24 1997 Erik Troan <ewt@redhat.com>
- built on Intel
- combined rmmod and insmod
